/*
The MIT License

 Copyright (c) 2005 - 2008
   1. Distributed Systems Group, University of Portsmouth (2005)
   2. Community Grids Laboratory, Indiana University (2005)
   3. Aamir Shafi (2005 - 2008)
   4. Bryan Carpenter (2005 - 2008)
   5. Mark Baker (2005 - 2008)

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
/*
 * File         : Buddy2Buffer.java
 * Author       : Aamir Shafi, Bryan Carpenter
 * Created      : Sat July 9 12:22:15 BST 2005
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 2005/08/12 19:12:25 $
 *    
 */
package mpjbuf ;

import java.nio.ByteBuffer ; 

public class Buddy2Buffer extends mpjbuf.NIOBuffer {
 
  Buddy2Buffer () {
  }

  public Buddy2Buffer(ByteBuffer slicedBuffer, int bufoffset, int capacity,
		  int level, Buddy2Region region, int realOffset ) {

     super(capacity, slicedBuffer) ;
     this.free = true;
     this.level = level;
     this.region = region ;
     this.realOffset = realOffset ;
     this.capacity = capacity ;

  }

  public int level, realOffset;

  int capacity ;  //there is a capacity in Buffer class but with private access
  
  public boolean free ;

  public Buddy2Region region; 

  Buddy2Buffer next, prev ;

}
